Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision 4d9fe7b307128cbbbd04d982fef935c842053872)
+++ uspace/Makefile	(revision c6533a794620411b83c209fe9e2c6bb24cedc08c)
@@ -65,5 +65,4 @@
 	app/nettest2 \
 	app/nettest3 \
-	app/ping \
 	app/websrv \
 	app/sysinfo \
Index: uspace/app/netecho/print_error.c
===================================================================
--- uspace/app/netecho/print_error.c	(revision 4d9fe7b307128cbbbd04d982fef935c842053872)
+++ uspace/app/netecho/print_error.c	(revision c6533a794620411b83c209fe9e2c6bb24cedc08c)
@@ -40,69 +40,7 @@
 #include <errno.h>
 
-#include <net/icmp_codes.h>
-
-/** Prints the specific ICMP error description.
- *
- * @param[in] output The description output stream. May be NULL.
- * @param[in] error_code The ICMP error code.
- * @param[in] prefix The error description prefix. May be NULL.
- * @param[in] suffix The error description suffix. May be NULL.
- */
-void icmp_print_error(FILE *output, int error_code, const char *prefix, const char *suffix)
-{
-	if (!output)
-		return;
-	
-	if (prefix)
-		fprintf(output, "%s", prefix);
-		
-	switch (error_code) {
-	case ICMP_DEST_UNREACH:
-		fprintf(output, "ICMP Destination Unreachable (%d) error", error_code);
-		break;
-	case ICMP_SOURCE_QUENCH:
-		fprintf(output, "ICMP Source Quench (%d) error", error_code);
-		break;
-	case ICMP_REDIRECT:
-		fprintf(output, "ICMP Redirect (%d) error", error_code);
-		break;
-	case ICMP_ALTERNATE_ADDR:
-		fprintf(output, "ICMP Alternate Host Address (%d) error", error_code);
-		break;
-	case ICMP_ROUTER_ADV:
-		fprintf(output, "ICMP Router Advertisement (%d) error", error_code);
-		break;
-	case ICMP_ROUTER_SOL:
-		fprintf(output, "ICMP Router Solicitation (%d) error", error_code);
-		break;
-	case ICMP_TIME_EXCEEDED:
-		fprintf(output, "ICMP Time Exceeded (%d) error", error_code);
-		break;
-	case ICMP_PARAMETERPROB:
-		fprintf(output, "ICMP Paramenter Problem (%d) error", error_code);
-		break;
-	case ICMP_CONVERSION_ERROR:
-		fprintf(output, "ICMP Datagram Conversion Error (%d) error", error_code);
-		break;
-	case ICMP_REDIRECT_MOBILE:
-		fprintf(output, "ICMP Mobile Host Redirect (%d) error", error_code);
-		break;
-	case ICMP_SKIP:
-		fprintf(output, "ICMP SKIP (%d) error", error_code);
-		break;
-	case ICMP_PHOTURIS:
-		fprintf(output, "ICMP Photuris (%d) error", error_code);
-		break;
-	default:
-		fprintf(output, "Other (%d) error", error_code);
-	}
-
-	if (suffix)
-		fprintf(output, "%s", suffix);
-}
-
 /** Prints the error description.
  *
- * Supports ICMP and socket error codes.
+ * Supports socket error codes.
  *
  * @param[in] output The description output stream. May be NULL.
@@ -113,7 +51,5 @@
 void print_error(FILE *output, int error_code, const char *prefix, const char *suffix)
 {
-	if (IS_ICMP_ERROR(error_code))
-		icmp_print_error(output, error_code, prefix, suffix);
-	else if(IS_SOCKET_ERROR(error_code))
+	if(IS_SOCKET_ERROR(error_code))
 		socket_print_error(output, error_code, prefix, suffix);
 }
Index: uspace/drv/nic/e1k/Makefile
===================================================================
--- uspace/drv/nic/e1k/Makefile	(revision 4d9fe7b307128cbbbd04d982fef935c842053872)
+++ uspace/drv/nic/e1k/Makefile	(revision c6533a794620411b83c209fe9e2c6bb24cedc08c)
@@ -28,6 +28,6 @@
 
 USPACE_PREFIX = ../../..
-LIBS = $(LIBDRV_PREFIX)/libdrv.a $(LIBNET_PREFIX)/libnet.a $(LIBNIC_PREFIX)/libnic.a
-EXTRA_CFLAGS += -I$(LIBDRV_PREFIX)/include -I$(LIBNET_PREFIX)/include -I$(LIBNIC_PREFIX)/include
+LIBS = $(LIBDRV_PREFIX)/libdrv.a $(LIBNIC_PREFIX)/libnic.a
+EXTRA_CFLAGS += -I$(LIBDRV_PREFIX)/include -I$(LIBNIC_PREFIX)/include
 BINARY = e1k
 
Index: uspace/drv/nic/e1k/e1k.c
===================================================================
--- uspace/drv/nic/e1k/e1k.c	(revision 4d9fe7b307128cbbbd04d982fef935c842053872)
+++ uspace/drv/nic/e1k/e1k.c	(revision c6533a794620411b83c209fe9e2c6bb24cedc08c)
@@ -50,5 +50,4 @@
 #include <device/pci.h>
 #include <nic.h>
-#include <nil_remote.h>
 #include <ops/nic.h>
 #include "e1k.h"
Index: uspace/drv/nic/lo/Makefile
===================================================================
--- uspace/drv/nic/lo/Makefile	(revision 4d9fe7b307128cbbbd04d982fef935c842053872)
+++ uspace/drv/nic/lo/Makefile	(revision c6533a794620411b83c209fe9e2c6bb24cedc08c)
@@ -28,6 +28,6 @@
 
 USPACE_PREFIX = ../../..
-LIBS = $(LIBDRV_PREFIX)/libdrv.a $(LIBNET_PREFIX)/libnet.a $(LIBNIC_PREFIX)/libnic.a
-EXTRA_CFLAGS += -I$(LIBDRV_PREFIX)/include -I$(LIBNET_PREFIX)/include -I$(LIBNIC_PREFIX)/include
+LIBS = $(LIBDRV_PREFIX)/libdrv.a $(LIBNIC_PREFIX)/libnic.a
+EXTRA_CFLAGS += -I$(LIBDRV_PREFIX)/include -I$(LIBNIC_PREFIX)/include
 BINARY = lo
 
Index: uspace/drv/nic/ne2k/Makefile
===================================================================
--- uspace/drv/nic/ne2k/Makefile	(revision 4d9fe7b307128cbbbd04d982fef935c842053872)
+++ uspace/drv/nic/ne2k/Makefile	(revision c6533a794620411b83c209fe9e2c6bb24cedc08c)
@@ -28,6 +28,6 @@
 
 USPACE_PREFIX = ../../..
-LIBS = $(LIBDRV_PREFIX)/libdrv.a $(LIBNET_PREFIX)/libnet.a $(LIBNIC_PREFIX)/libnic.a
-EXTRA_CFLAGS += -I$(LIBDRV_PREFIX)/include -I$(LIBNET_PREFIX)/include -I$(LIBNIC_PREFIX)/include
+LIBS = $(LIBDRV_PREFIX)/libdrv.a $(LIBNIC_PREFIX)/libnic.a
+EXTRA_CFLAGS += -I$(LIBDRV_PREFIX)/include -I$(LIBNIC_PREFIX)/include
 BINARY = ne2k
 
Index: uspace/drv/nic/rtl8139/Makefile
===================================================================
--- uspace/drv/nic/rtl8139/Makefile	(revision 4d9fe7b307128cbbbd04d982fef935c842053872)
+++ uspace/drv/nic/rtl8139/Makefile	(revision c6533a794620411b83c209fe9e2c6bb24cedc08c)
@@ -28,6 +28,6 @@
 
 USPACE_PREFIX = ../../..
-LIBS = $(LIBDRV_PREFIX)/libdrv.a $(LIBNET_PREFIX)/libnet.a $(LIBNIC_PREFIX)/libnic.a
-EXTRA_CFLAGS += -I$(LIBDRV_PREFIX)/include -I$(LIBNET_PREFIX)/include -I$(LIBNIC_PREFIX)/include
+LIBS = $(LIBDRV_PREFIX)/libdrv.a $(LIBNIC_PREFIX)/libnic.a
+EXTRA_CFLAGS += -I$(LIBDRV_PREFIX)/include -I$(LIBNIC_PREFIX)/include
 BINARY = rtl8139
 
Index: uspace/drv/nic/rtl8139/driver.c
===================================================================
--- uspace/drv/nic/rtl8139/driver.c	(revision 4d9fe7b307128cbbbd04d982fef935c842053872)
+++ uspace/drv/nic/rtl8139/driver.c	(revision c6533a794620411b83c209fe9e2c6bb24cedc08c)
@@ -44,6 +44,4 @@
 #include <sysinfo.h>
 #include <ipc/ns.h>
-
-#include <net_checksum.h>
 
 #include <str.h>
Index: uspace/lib/c/Makefile
===================================================================
--- uspace/lib/c/Makefile	(revision 4d9fe7b307128cbbbd04d982fef935c842053872)
+++ uspace/lib/c/Makefile	(revision c6533a794620411b83c209fe9e2c6bb24cedc08c)
@@ -118,8 +118,5 @@
 	generic/vfs/canonify.c \
 	generic/net/inet.c \
-	generic/net/icmp_common.c \
-	generic/net/icmp_api.c \
 	generic/net/modules.c \
-	generic/net/packet.c \
 	generic/net/socket_client.c \
 	generic/net/socket_parse.c \
Index: uspace/lib/c/include/ipc/net.h
===================================================================
--- uspace/lib/c/include/ipc/net.h	(revision 4d9fe7b307128cbbbd04d982fef935c842053872)
+++ uspace/lib/c/include/ipc/net.h	(revision c6533a794620411b83c209fe9e2c6bb24cedc08c)
@@ -40,5 +40,4 @@
 #include <ipc/services.h>
 #include <net/device.h>
-#include <net/packet.h>
 
 /** Return a value indicating whether the value is in the interval.
Index: uspace/lib/net/Makefile
===================================================================
--- uspace/lib/net/Makefile	(revision 4d9fe7b307128cbbbd04d982fef935c842053872)
+++ uspace/lib/net/Makefile	(revision c6533a794620411b83c209fe9e2c6bb24cedc08c)
@@ -33,24 +33,5 @@
 
 SOURCES = \
-	generic/generic.c \
-	generic/net_remote.c \
-	generic/net_checksum.c \
-	generic/packet_client.c \
-	generic/packet_remote.c \
-	generic/protocol_map.c \
-	adt/module_map.c \
-	nil/nil_remote.c \
-	nil/nil_skel.c \
-	il/il_remote.c \
-	il/il_skel.c \
-	il/ip_remote.c \
-	il/ip_client.c \
-	il/arp_remote.c \
-	tl/icmp_remote.c \
-	tl/icmp_client.c \
-	tl/socket_core.c \
-	tl/tl_common.c \
-	tl/tl_remote.c \
-	tl/tl_skel.c
+	tl/socket_core.c
 
 include $(USPACE_PREFIX)/Makefile.common
Index: uspace/lib/net/include/socket_core.h
===================================================================
--- uspace/lib/net/include/socket_core.h	(revision 4d9fe7b307128cbbbd04d982fef935c842053872)
+++ uspace/lib/net/include/socket_core.h	(revision c6533a794620411b83c209fe9e2c6bb24cedc08c)
@@ -44,5 +44,4 @@
 #include <net/in.h>
 #include <net/device.h>
-#include <net/packet.h>
 #include <async.h>
 
@@ -80,6 +79,4 @@
 	/** Bound port. */
 	int port;
-	/** Received packets queue. */
-	dyn_fifo_t received;
 	/** Sockets for acceptance queue. */
 	dyn_fifo_t accepted;
@@ -118,5 +115,4 @@
 extern int socket_destroy(async_sess_t *, int, socket_cores_t *,
     socket_ports_t *, void (*)(socket_core_t *));
-extern int socket_reply_packets(packet_t *, size_t *);
 extern socket_core_t *socket_port_find(socket_ports_t *, int, const uint8_t *,
     size_t);
Index: uspace/lib/net/tl/socket_core.c
===================================================================
--- uspace/lib/net/tl/socket_core.c	(revision 4d9fe7b307128cbbbd04d982fef935c842053872)
+++ uspace/lib/net/tl/socket_core.c	(revision c6533a794620411b83c209fe9e2c6bb24cedc08c)
@@ -36,10 +36,7 @@
 
 #include <socket_core.h>
-#include <packet_client.h>
-#include <packet_remote.h>
 #include <net/socket_codes.h>
 #include <net/in.h>
 #include <net/inet.h>
-#include <net/packet.h>
 #include <net/modules.h>
 #include <stdint.h>
@@ -92,10 +89,4 @@
 	}
 	
-	/* Release all received packets */
-	int packet_id;
-	while ((packet_id = dyn_fifo_pop(&socket->received)) >= 0)
-		pq_release_remote(sess, packet_id);
-	
-	dyn_fifo_destroy(&socket->received);
 	dyn_fifo_destroy(&socket->accepted);
 	
@@ -448,20 +439,13 @@
 	socket->key_length = 0;
 	socket->specific_data = specific_data;
-	rc = dyn_fifo_initialize(&socket->received, SOCKET_INITIAL_RECEIVED_SIZE);
+	
+	rc = dyn_fifo_initialize(&socket->accepted, SOCKET_INITIAL_ACCEPTED_SIZE);
 	if (rc != EOK) {
 		free(socket);
 		return rc;
 	}
-	
-	rc = dyn_fifo_initialize(&socket->accepted, SOCKET_INITIAL_ACCEPTED_SIZE);
-	if (rc != EOK) {
-		dyn_fifo_destroy(&socket->received);
-		free(socket);
-		return rc;
-	}
 	socket->socket_id = *socket_id;
 	rc = socket_cores_add(local_sockets, socket->socket_id, socket);
 	if (rc < 0) {
-		dyn_fifo_destroy(&socket->received);
 		dyn_fifo_destroy(&socket->accepted);
 		free(socket);
@@ -506,87 +490,4 @@
 	socket_destroy_core(sess, socket, local_sockets, global_sockets,
 	    socket_release);
-	
-	return EOK;
-}
-
-/** Replies the packet or the packet queue data to the application via the
- * socket.
- *
- * Uses the current message processing fibril.
- *
- * @param[in] packet	The packet to be transfered.
- * @param[out] length	The total data length.
- * @return		EOK on success.
- * @return		EBADMEM if the length parameter is NULL.
- * @return		ENOMEM if there is not enough memory left.
- * @return		Other error codes as defined for the data_reply()
- *			function.
- */
-int socket_reply_packets(packet_t *packet, size_t *length)
-{
-	packet_t *next_packet;
-	size_t fragments;
-	size_t *lengths;
-	size_t index;
-	int rc;
-
-	if (!length)
-		return EBADMEM;
-
-	next_packet = pq_next(packet);
-	if (!next_packet) {
-		/* Write all if only one fragment */
-		rc = data_reply(packet_get_data(packet),
-		    packet_get_data_length(packet));
-		if (rc != EOK)
-			return rc;
-		/* Store the total length */
-		*length = packet_get_data_length(packet);
-	} else {
-		/* Count the packet fragments */
-		fragments = 1;
-		next_packet = pq_next(packet);
-		while ((next_packet = pq_next(next_packet)))
-			++fragments;
-		
-		/* Compute and store the fragment lengths */
-		lengths = (size_t *) malloc(sizeof(size_t) * fragments +
-		    sizeof(size_t));
-		if (!lengths)
-			return ENOMEM;
-		
-		lengths[0] = packet_get_data_length(packet);
-		lengths[fragments] = lengths[0];
-		next_packet = pq_next(packet);
-		
-		for (index = 1; index < fragments; ++index) {
-			lengths[index] = packet_get_data_length(next_packet);
-			lengths[fragments] += lengths[index];
-			next_packet = pq_next(packet);
-		}
-		
-		/* Write the fragment lengths */
-		rc = data_reply(lengths, sizeof(int) * (fragments + 1));
-		if (rc != EOK) {
-			free(lengths);
-			return rc;
-		}
-		next_packet = packet;
-		
-		/* Write the fragments */
-		for (index = 0; index < fragments; ++index) {
-			rc = data_reply(packet_get_data(next_packet),
-			    lengths[index]);
-			if (rc != EOK) {
-				free(lengths);
-				return rc;
-			}
-			next_packet = pq_next(next_packet);
-		}
-		
-		/* Store the total length */
-		*length = lengths[fragments];
-		free(lengths);
-	}
 	
 	return EOK;
